/*
 * EpsilonClosure.cpp
 *
 *  Created on: 16. 1. 2014
 *      Author: tomas
 */

#include "EpsilonClosure.h"

using namespace alib;
using namespace automaton;
using namespace std;

namespace epsilon
{

set<State> EpsilonClosure::closure( FSM const& fsm, State const& q )
{
    set<State> closure;
    queue<State> queue;
    map<State, bool> visited;

    for( const auto & p : fsm.getStates( ) )
        visited[ p ] = false;

    queue.push( q );
    while( ! queue.empty( ) )
    {
        const State & p = queue.front( );
        queue.pop( );
        visited[ p ] = true;
        closure.insert( p );

        for( const auto & transition : fsm.getTransitionsFromState( p ) )
            if( transition.getInput( ) == Symbol( "" ) && visited [ transition.getTo( ) ] == false )
                queue.push( transition.getTo( ) );
    }

    return closure;
}

} /* namespace epsilon */
