/*
 * RandomAutomatonFactory.h
 *
 *  Created on: 27. 3. 2014
 *      Author: tomas
 */

#ifndef RANDOMAUTOMATONFACTORY_H_
#define RANDOMAUTOMATONFACTORY_H_

#include <deque>
#include <map>
#include <set>
#include <algorithm>

#include <AlibException.h>
#include <automaton/FSM/FSM.h>

#define isInSet(x,set) ((set).find((x)) != (set).end( ) )

class RandomAutomatonFactory
{
public:
    static automaton::FSM generateNFA( size_t statesCount, std::set<alphabet::Symbol> alphabet, double density );
    static automaton::FSM generateNFA( size_t statesCount, size_t alphabetSize, double density );

private:
    static automaton::FSM LeslieConnectedNFA( size_t n, const std::deque<alphabet::Symbol> & alphabet, double density );
};

#endif /* RANDOMAUTOMATONFACTORY_H_ */
